(function() {
    const DEF_WORKER_URL = "compression-worker.js";

    if(!window.apeApps) {
        window.apeApps = {};
    }

    if(!window.apeApps.utilities) {
        window.apeApps.utilities = {};
    }

    window.apeApps.utilities.compressionHelper = {};

    window.apeApps.utilities.compressionHelper.compress = function(options) {

        let url = DEF_WORKER_URL;
        let callback = null;
        let data = null;
        
        if(options) {
            if(options.url) {
                url = options.url;
            }

            if(options.callback) {
                callback = options.callback;
            }

            if(options.data) {
                data = options.data;
            }
        }

        if(!url || !callback || !data) {

            if(callback) {
                callback(null);
            }

            return;
        }

        doCompressionWork(url,data,"compress",callback);
    };

    window.apeApps.utilities.compressionHelper.decompress = function(options) {

        let url = DEF_WORKER_URL;
        let callback = null;
        let data = null;
        
        if(options) {
            if(options.url) {
                url = options.url;
            }

            if(options.callback) {
                callback = options.callback;
            }

            if(options.data) {
                data = options.data;
            }
        }

        if(!url || !callback || !data) {

            if(callback) {
                callback(null);
            }

            return;
        }

        doCompressionWork(url,data,"decompress",callback);
    };

    function doCompressionWork(url,data,method,callback) {
        let cw = new Worker(url);
        cw.onmessage = function(ev) {
            callback(ev.data.data);
        };
        cw.onerror = function(){
            callback(null);
        };
        cw.postMessage({
            method: method,
            data: data
        });
    }
})();