﻿/* global Android */
/* global html2canvas */
/* global adl */
window.addEventListener("resize",sizeElements,false);
window.addEventListener("load",initApp,false);
window.addEventListener("error",onGeneralError,false);
window.addEventListener("unload",onUnload,false);
window.addEventListener("message",onMessage,false);

// elements
let appFrame;
let appWrapper;
let titleScreen;
let titleScreenLogo;
let titleScreenOptions;
let titleScreenFeaturedApp;
let titleScreenNewsfeed;
let titleScreenApeLogo;
let titleScreenSubtitle;
let toolbarHolder;
let bottomToolbarHolder;
let introFader;
let chatHolder;
let chatHolderToolbar;
let chatHolderFrame;

let tmpOutputDiv;
let currentFrameURL;
let remoteip;

let childWindowObject = null;
let chatiFrame = null;
let currentGamepadElement = null;
let currentChatRoom = null;
let currentTitle = null;
let sidebarCategory = null;
let sidebarCategoryIcon = null;
let lastTheme = null;
let fileSelector = null;
let signalSocket = null;
let friendSelectedCallback = null;
let tmpFriendWindow = null;
let lastFriendsStatus = null;

let titleGoosed = false;
let appIsInit = false;
let signalSocketConnected = false;

let premiumText = "Remove Advertising";
let textToShare = "";

let customMenu = [];
let customToolbar = [];

let friendOnlineStatus = {};

function initApp() {
    window.useToolbar = Android.getUsesToolbar();

    window.fetch = null;

    let fetchScript = document.createElement("script");
    fetchScript.onload = function(){
        setTimeout(moreInit,70);
    };
    fetchScript.src = "js/fetchpolyfill.js";
    document.head.appendChild(fetchScript);
}

function moreInit() {
    fileSelector = document.createElement("input");
    fileSelector.setAttribute("type", "file");
    fileSelector.addEventListener("change",onInputFileSelected,false);

    tryToGetRemoteIpAndLocation();

    linkLayouts();
    completeInit();
}

function onMessage(e) {
    if(e.origin == "https://www.apewebapps.com") {
        if(e.data.msg) {
            let msg = e.data.msg;
            let data = e.data.data;

            console.log(msg);

            if(msg == "needslogin" && tmpFriendWindow) {
                let creds = JSON.parse(Android.getApeAppsCreds());
                let apeMarketId = Android.getApeMarketId();

                let retDat = {
                    "func": "onApeAppsLogin",
                    "data": {
                        "sida": creds.a,
                        "sidb": creds.b,
                        "sidc": creds.c,
                        "am": apeMarketId
                    }
                };

                tmpFriendWindow.contentWindow.postMessage(retDat,"*");
            }

            if(msg == "loadprofile" && tmpFriendWindow) {
                if(friendSelectedCallback) {
                    let cb = friendSelectedCallback;
                    friendSelectedCallback = null;
                    cb(data);
                }

                adl.dismissDialogWindow();
            }
        }
    }
}

function onUnload() {
    closeSignalSocketConnection();
}

// eslint-disable-next-line no-unused-vars
function force720() {
    document.getElementById("viewportMeta").content = "initial-scale=1.5, user-scalable=no";
}

function completeInit() {
    if(appIsInit) {
        return;
    }

    audioArray = [];
    loopingAudio = document.createElement("audio");

    prepareTitleScreen();

    appFrame.src = window.appUrl;
    window.appUrl = appFrame.src;

    childWindowObject = appFrame.contentWindow;

    appIsInit = true;
    sizeElements();
}

// eslint-disable-next-line no-unused-vars
function onGamepadDown(id,key) {
    gamepadDown(key,id);
}

// eslint-disable-next-line no-unused-vars
function onGamepadUp(id,key) {
    gamepadUp(key,id);
}

function gamepadDown(key,id) {

    if(!appFrame || !childWindowObject.webAppCore) {
        return;
    }

    console.log(key);

    if(key == "up" || key == "down" || key == "left" || key == "right") {
        let selectedElement = adl.gamepadXYCheck(key,currentGamepadElement);

        if(currentGamepadElement) {
            currentGamepadElement.classList.remove("adlGamepadSelected");
        }

        if(selectedElement) {
            currentGamepadElement = selectedElement;
            currentGamepadElement.classList.add("adlGamepadSelected");
            currentGamepadElement.scrollIntoView(false);

            return;
        } else {
            currentGamepadElement = null;
        }
        
    }

    if(key == "a" && currentGamepadElement) {
        if(adl.canElementBeGamepadSelected(currentGamepadElement)) {
            if(currentGamepadElement.type && (currentGamepadElement.type == "text" || currentGamepadElement.type == "password")) {
                currentGamepadElement.focus();
                Android.showKeyboardOnTv();
            } else {
                currentGamepadElement.click();
            }

            return;
        } else {
            currentGamepadElement = null;
        }
    }

    if(key == "b") {

        if(currentGamepadElement) {
            currentGamepadElement.classList.remove("adlGamepadSelected");
        }

        currentGamepadElement = null;

        if(adl.dismissDialogWindow()) {
            return;
        }
    }

    /*
    pendingGamepadDirectionKey = key;
    pendingGamepadId = id;
    */

    // check if we are handling the title screen
    /*
    if(document.getElementById("introScreen").style.display == "block") {
        titlescreenGamepadDown(key);
        return;
    }
    */

    childWindowObject.webAppCore.recieveGamepadDown(key,id);
}

function gamepadUp(key,id) {

    if(!appFrame || childWindowObject.webAppCore == null) {
        return;
    }



    //killScrollTimeout();
    childWindowObject.webAppCore.recieveGamepadUp(key,id);

    if(currentGamepadElement) {
        currentGamepadElement.focus();
    }
}

// eslint-disable-next-line no-unused-vars
function notifyURL(url) {
    currentFrameURL = url;
    notifyPlatformNavigation();
}

let signalCloserTimeout = null;

// eslint-disable-next-line no-unused-vars
function onPause() {
    if(!appFrame) {
        return;
    }

    if(childWindowObject.webAppCore != null && childWindowObject.webAppCore.onPause != null) {
        childWindowObject.webAppCore.onPause();
    }

    signalCloserTimeout = setTimeout(closeSignalSocketConnection,30000);
}

// eslint-disable-next-line no-unused-vars
function onResume() {

    if(!appFrame) {
        appIsInit = false;
        initApp();
        return;
    }

    if(childWindowObject.webAppCore != null && childWindowObject.webAppCore.onResume != null) {
        childWindowObject.webAppCore.onResume();
    }

    if(signalCloserTimeout) {
        try {
            clearTimeout(signalCloserTimeout);
            signalCloserTimeout = null;
        } catch(ex) {
            console.log(ex);
            signalCloserTimeout = null;
        }

    }

    connectToFriendsSignalingServer();
}

// eslint-disable-next-line no-unused-vars
function onBack() {
    childWindowObject.webAppCore.onBack();
}

function linkLayouts() {
    appWrapper = document.getElementById("appWrapper");
    toolbarHolder = document.getElementById("toolbarHolder");
    bottomToolbarHolder = document.getElementById("bottomToolbarHolder");
    chatHolder = document.getElementById("chatHolder");
    chatHolderToolbar = document.getElementById("chatHolderToolbar");
    chatHolderFrame = document.getElementById("chatHolderFrame");
    appFrame = document.getElementById("appFrame");

    titleScreen = document.getElementById("titleScreen");
    titleScreenLogo = document.getElementById("titleScreenLogo");
    titleScreenOptions = document.getElementById("titleScreenOptions");
    titleScreenFeaturedApp = document.getElementById("titleScreenFeaturedApp");
    titleScreenNewsfeed = document.getElementById("titleScreenNewsfeed");
    titleScreenApeLogo = document.getElementById("titleScreenApeLogo");
    titleScreenSubtitle = document.getElementById("titleScreenSubtitle");

    introFader = document.getElementById("introFader");

    if(appFrame != null) {
        appFrame.addEventListener("error",onFrameError,false);
    }

    document.getElementById("gPlaySignInLogo").onclick = function(){
        Android.doPlayGamesSignIn();
    };
}

function toggleMenu(fromToolbar) {
    if(window.useToolbar && !fromToolbar) {
        return;
    }

    let listOptions = [];

    if(Android.isApeAppsLoggedIn()) {

        let apeProfile = getApeAppsProfile();

        listOptions.push({
            title: apeProfile.un,
            icon: "https://accounts.ape-apps.com/getavatar.php?u=" + apeProfile.un,
            tag: {
                wacTag: null,
                func: showProfileOptions
            },
            compactItem: true
        });

    } else {
        listOptions.push({
            title: "Sign In",
            icon: "person-circle-outline",
            tag: {
                wacTag: null,
                func: function(){
                    Android.showApeLogin();
                }
            },
            compactItem: true
        });

    }

    for(let i = 0; i < customMenu.length; i++) {
        let item = customMenu[i];

        if(item.wacIsAd) {
            if(Android.getPlatform() == "2") {
                continue;
            }
        }

        listOptions.push({
            title: item.title,
            icon: getCleanIcon(item.icon),
            tag: item,
            compactItem: true
        });
    }

    let categoryOption = null;

    // default menu items 
    if(sidebarCategory) {
        let sbIcon = "list-outline";

        if(sidebarCategoryIcon) {
            sbIcon = getCleanIcon(sidebarCategoryIcon);
        }

        categoryOption = {
            title: sidebarCategory,
            icon: sbIcon,
            tag: "sidebarCategory",
            compactItem: true
        };
    } else {
        let sbIcon = "list-outline";

        categoryOption = {
            title: "Latest Updates",
            icon: sbIcon,
            tag: "sidebarCategory",
            compactItem: true
        };

    }

    if(categoryOption) {
        listOptions.push(categoryOption);
    }

    if(!getIsPremium()) {
        listOptions.push({
            title: premiumText,
            icon: "cart-outline",
            tag: "gopremium",
            compactItem: true
        });
    }



    listOptions.push({
        title: "Share " + window.appName,
        icon: "share-social-outline",
        tag: "share",
        compactItem: true
    });

    listOptions.push({
        title: "Send Feedback",
        icon: "mail-outline",
        tag: "feedback",
        compactItem: true
    });

    listOptions.push({
        title: "About " + window.appName,
        icon: "information-circle-outline",
        tag: "about",
        compactItem: true
    });

    adl.showList({
        title: window.appName,
        options: listOptions,
        onSelection: function(tag) {

            if(tag) {

                if(tag == "gopremium") {
                    goPremium();
                    return;
                }

                if(tag == "about") {
                    presentAbout();
                    return;
                }

                if(tag == "feedback") {
                    presentFeedbackWindow();
                    return;
                }

                if(tag == "share") {
                    performStandardShare();
                    return;
                }

                if(tag == "sidebarCategory") {
                    showCategoriesFromSidebar();
                    return;
                }

            }

            if(tag && tag.func) {
                console.log("EXECUTE IT");
                tag.func(tag.wacTag);
            } else {
                console.log("WTF");
            }
        },
        flyout: {
            position: "left"
        }
    });
}


function sizeElements() {

    if(!appIsInit) {
        return;
    }

    if(appFrame == undefined) {
        appFrame = document.getElementById("appFrame");
    }

}

// eslint-disable-next-line no-unused-vars
function showColorPicker(defCol) {

    if(!defCol) {
        defCol = lastTheme;
    }

    adl.pickColor({
        callback: function(color){
            childWindowObject.webAppCore.colorSelected(color);
        },
        withInput: true,
        default: defCol
    });

    //Android.pickColor(defCol);
}

// eslint-disable-next-line no-unused-vars
function onMenuPress() {
    if(!appFrame || !childWindowObject.webAppCore) {
        return;
    }
	
    childWindowObject.webAppCore.revieveMenuPress();
}

function colorSelected(color) {
    childWindowObject.webAppCore.colorSelected(color);
}

function wacMidiPlaybackComplete() {
    if(!appFrame || !childWindowObject.webAppCore) {
        return;
    }
	
    childWindowObject.webAppCore.midiCallbackListener();
}

// eslint-disable-next-line no-unused-vars
function addMenuOption(name,icon,color,tag,subMenu,isAd) {

    let menuItem = {};

    if(name) {
        menuItem.title = name;
    }

    if(icon) {
        menuItem.icon = icon;
    }

    if(color) {
        menuItem.iconColor = color;
    }

    if(subMenu) {
        menuItem.wacSubmenu = subMenu;
    }

    if(isAd) {
        menuItem.wacIsAd = isAd;
    }

    if(tag) {
        menuItem.wacTag = tag;
    }

    menuItem.func = function(){
        console.log("boom");
        childWindowObject.webAppCore.executeMenuFunction(name,tag);
    };

    customMenu.push(menuItem);

    rebuildToolbar();
}

function navItemSelection(name,tag) {
    childWindowObject.webAppCore.executeMenuFunction(name,tag);
}

function resetCustomMenu() {
    //Android.clearNavbar();
    customMenu = [];
    rebuildToolbar();
}

function forceCloseMenu() {
    // hrmm
}

function clearSplash() {
    clearPlatformSplash();
}

/*
function saveScreenshot(element) {
    if(!element) {
        element = childWindowObject.document.body;
    }

    if(element.nodeName.toLowerCase() == "canvas") {
        processScreenshot(element);
        return;
    }

    html2canvas(element, {
        allowTaint: true
    }).then(function(canvas) {
        processScreenshot(canvas);
    });

}
*/

function generateDate() {
    let today = new Date();
    let dd = today.getDate();
    let mm = today.getMonth()+1; //January is 0!

    let yyyy = today.getFullYear();
    if(dd<10){
        dd="0"+dd;
    }
    if(mm<10){
        mm="0"+mm;
    }
    return mm+"/"+dd+"/"+yyyy;
}

function logEvent(category,action,label) {
    Android.trackEvent(category,action,label, false);
}

function closeOrConfirmAlert() {
    //for legacy purposes
}

function wacChoice1() {
    childWindowObject.webAppCore.choice1();
}

function wacChoice2() {
    childWindowObject.webAppCore.choice2();
}

function wacInputReturn(text) {
    if(inputCallbackFunction) {
        inputCallbackFunction(text);
    } else {
        childWindowObject.webAppCore.inputReturn(text);
    }
}

let inputCallbackFunction = undefined;

/*
function inputBox(message,func,isScreenshot) {

    inputCallbackFunction = func;
    Android.inputBox(message,null,false);
}
*/

function finalizePremiumAndRemoveBannerAds() {
    storeVar(window.webAppId + "_premium_upgrade","1");

    if(!appFrame || !childWindowObject.webAppCore) {
        return;
    }

    childWindowObject.webAppCore.onPremiumUpgraded();
}

function getCleanIcon(icon) {
    if(icon && (icon.endsWith(".png") || icon.indexOf("data:") > -1 || icon.indexOf("https:") > -1)) {
        if(icon.indexOf("http") != 0 && icon.indexOf("data:") == -1 && icon.indexOf("file:") == -1) {
            icon = "app/" + icon;
        }
    }

    return icon;
}

// Web App Core v3.1 Functions
function addToolbarItem(name,tag,icon,inSecondarySection) {
    //Android.addToolbarItem(name,tag,icon,inSecondarySection);

    customToolbar.push({
        title: name,
        func: function() {
            childWindowObject.webAppCore.executeToolbarFunction(name,tag);
        },
        icon: getCleanIcon(icon),
        wacInSecondary: inSecondarySection
    });

    rebuildToolbar();
}

function resetCustomToolbar() {
    //Android.resetToolbar();
    customToolbar = [];
    rebuildToolbar();
}

function toggleToolbar() {
    //Android.toggleToolbar();

    window.useToolbar = !window.useToolbar;
    rebuildToolbar();
}

function toolbarItemSelected(name,tag) {
    childWindowObject.webAppCore.executeToolbarFunction(name,tag);
}

function setTitle(title) {
    currentTitle = title;
    rebuildToolbar();
}

function prepareTitleScreen() {

    if(Android.getPlatform() == "2" || window.isTvDevice) {
        titleScreenApeLogo.style.display = "none";
    }

    titleScreenLogo.addEventListener("click",performStandardShare,false);

    if(window.isTvDevice) {
        titleScreenFeaturedApp.style.display = "none";
    } else {
        fetchFeaturedImage(titleScreenFeaturedApp);
    }
}

function performStandardShare() {
    toggleShareBox("Check out " + Android.getAppName() + "! #appurl");
}

let featureHolder;

function fetchFeaturedImage(output) {
    if(getIsPremium()) {
        output.style.display = "none";
        return;
    }

    if(Android.getIsTvDevice()) {
        output.style.display = "none";
        return;
    }

    featureHolder = output;

    let platformId = Android.getPlatform();

    if(platformId == "2") {
        output.style.display = "none";
        return;
    }

    let apeMarketId = Android.getApeMarketId();
    let buster = "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function (c) {
        let r = Math.random() * 16 | 0, v = c == "x" ? r : (r & 0x3 | 0x8);
        return v.toString(16);
    });

    let scoreData = [];
    scoreData[scoreData.length] = {key:"p",value:platformId};
    scoreData[scoreData.length] = {key:"a",value:apeMarketId};
    scoreData[scoreData.length] = {key:"zzz",value:buster};

    dataRequest("https://market.ape-apps.com/app_resources/featured_app.php",showFeature,scoreData,false);
}

function showFeature(data) {
    if(!featureHolder || featureHolder == null) {
        return;
    }

    console.log("parsing feature");

    let imageURL = data.split("###");

    featureHolder.src = "https://market.ape-apps.com/app_icons/" + imageURL[0];
    featureHolder.linkRef = imageURL[1];
    featureHolder.onclick = function () {
        let featurePrexif = Android.getFeaturePrefix();

        loadURL(featurePrexif + this.linkRef);
    };

}

function getNewsfeed(output) {
    if(!output) {
        return;
    }

    let platformId = Android.getPlatform();

    if(platformId == "2") {
        output.style.display = "none";
        return;
    }

    tmpOutputDiv = output;

    dataRequest("https://market.ape-apps.com/app_resources/title-newsfeed.php",printNewsfeed,null,false);
}

function printNewsfeed(data) {
    if(!tmpOutputDiv || tmpOutputDiv == null) {
        return;
    }

    if (data.indexOf("###") == -1) {
        tmpOutputDiv.innerHTML = data;
    } else {
        let newsParts = [];
        newsParts = data.split("###");
        tmpOutputDiv.innerHTML = newsParts[0];
        tmpOutputDiv.addEventListener("click",function(event) {
            event.preventDefault();
            loadURL(newsParts[1]);
        },false);
        tmpOutputDiv.style.cursor = "pointer";
    }

    try {
        tmpOutputDiv.start();
    } catch(e) {
        //ohwell
    }
    tmpOutputDiv = null;
}

// eslint-disable-next-line no-unused-vars
function setTitleVisible(visible) {

    if(visible) {
        doInitialTitleGoose();
        titleScreen.style.display = "grid";
    } else {
        titleScreen.style.display = "none";
    }

    Android.checkForPlayGamesButtion();
}

function doInitialTitleGoose() {
    if(titleGoosed) {
        return;
    }

    titleScreenApeLogo.onclick = function(){
        loadURL("https://www.ape-apps.com");
    };

    fetchFeaturedImage(titleScreenFeaturedApp);

    if(getIsPremium() || Android.getPlatform() == "2" || Android.getIsTvDevice()) {
        titleScreenNewsfeed.style.display = "none";
    } else {
        getNewsfeed(titleScreenNewsfeed);
    }

    titleGoosed = true;
}

function setPlayGamesButtonVisible(show) {
    if(show) {
        document.getElementById("gPlaySignInLogo").style.display = "block";
    } else {
        document.getElementById("gPlaySignInLogo").style.display = "none";
    }
}

function setTitleBackground(bgHTML) {
    let hasbg = bgHTML.indexOf("url('");
    if(hasbg > -1) {
        let n = bgHTML.indexOf("://");
        if(n == -1) {
            bgHTML = bgHTML.replace("url('","url('" + "app/");
        }
    }

    titleScreen.style.background = bgHTML;
}

function setTitleLogo(logo) {
    let n = logo.indexOf("://");
    if(n == -1) {
        titleScreenLogo.src = "app/" + logo;
    } else {
        titleScreenLogo.src = logo;
    }
}

function setBrandingLogo(logo) {
    if(logo == null) {
        titleScreenApeLogo.style.display = "none";
        return;
    }

    titleScreenApeLogo.style.display = null;

    let n = logo.indexOf("://");
    if(n == -1) {
        titleScreenApeLogo.src = "app/" + logo;
    } else {
        titleScreenApeLogo.src = logo;
    }
}

let opacitySetting = 0;

function fadeTitle(color) {

    opacitySetting = 0;

    introFader.style.backgroundColor = color;
    introFader.style.opacity = 0;
    introFader.style.display = "block";


    doFade();
}

function doFade() {

    opacitySetting += 0.05;

    introFader.style.opacity = opacitySetting;

    if(opacitySetting >= 1) {
        if(childWindowObject.webAppCore.titleFadeCallback != null) {
            childWindowObject.webAppCore.titleFadeCallback();
        }
    } else {
        setTimeout(doFade,50);
    }
}

function addTitleOption(name,tag,color,selectedColor) {
    let titleOption = document.createElement("div");
    titleOption.className = "titleOption adlGamepadSelectable";

    titleOption.innerHTML = name;

    if(color) {
        titleOption.style.color = color;
    }

    if(selectedColor) {
        titleOption.selectedColorRef = selectedColor;
    }

    titleOption.onclick = function(){
        childWindowObject.webAppCore.titleOptionSelected(tag);
    };

    titleScreenOptions.appendChild(titleOption);
}

function clearTitleOptions() {
    titleScreenOptions.innerHTML = "";
}

function dataRequest(url,callback,data,post) {
    let xmlhttp = new XMLHttpRequest();
    xmlhttp.callbackFunction = callback;

    let m = "GET";

    if(post) {
        m = "POST";
    }

    let params = "";

    if(data && data != null) {
        if(Array.isArray(data)) {
            for(let i = 0;i < data.length; i++) {
                if(i > 0) {
                    params = params + "&";
                }

                if(post) {
                    params = params + data[i].key + "=" + data[i].value;
                } else {
                    params = params + data[i].key + "=" + encodeURIComponent(data[i].value);
                }
            }
        } else {
            if (typeof data === "string" || data instanceof String) {
                params = data;
            } else {
                if(post) {
                    params = data.key + "=" + data.value;
                } else {
                    params = data.key + "=" + encodeURIComponent(data.value);
                }
            }
        }
    }

    xmlhttp.onreadystatechange=function() {
        if (xmlhttp.readyState==4 && xmlhttp.status==200) {
            this.callbackFunction(xmlhttp.responseText);
        }
    };

    if(!post && params.length > 0) {
        url = url + "?" + params;
    }

    xmlhttp.open(m,url,true);
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

    if(post) {
        console.log("sending post");
        xmlhttp.send(params);
    } else {
        console.log("sending get");
        xmlhttp.send();
    }
}

function postForResult(url,data) {
    dataRequest(url,wacResult,data,true);
}

function getForResult(url,data) {
    dataRequest(url,wacResult,data,false);
}

function wacResult(data) {
    childWindowObject.webAppCore.resultFunction(data);
}

function getIsPremium() {
    return Android.getIsPremium();
}

function setTitleSubtitle(text) {

    if(text.trim().length == 0) {
        titleScreenSubtitle.style.display = "none";
        return;
    }
    
    titleScreenSubtitle.style.display = "block";
    titleScreenSubtitle.innerHTML = text;
}

// eslint-disable-next-line no-unused-vars
function onToastActionPressed() {
    if(childWindowObject.webAppCore) {
        childWindowObject.webAppCore.toastBack();
    }
}

function notifyPlatformNavigation(url)  {
    startReportingShake = false;
    Android.setSensorActivation(false,0);
    Android.stopLocationListening();

    sizeElements();
}

// eslint-disable-next-line no-unused-vars
function wacImageBackParseFirst(data) {
    let parsed = JSON.parse(data);
    childWindowObject.webAppCore.picImportCallbackHook(parsed);
}

function wacImageBack() {
    let data = Android.getPreparedFinalImageData();

    console.log(data);

    childWindowObject.webAppCore.picImportCallbackHook(data);
}

// eslint-disable-next-line no-unused-vars
function showPopupMenu(options) {

    for(let i = 0; i < options.items.length; i++) {
        let item = options.items[i];

        if(item.type && item.type == "separator") {
            continue;
        }

        addPopupCallback(item,options.callback);
    }

    let title = null;

    if(options.title) {
        title = options.title;
    }

    adl.popupMenu({
        items: options.items,
        title: title
    },options.x,options.y);

}

function addPopupCallback(item,callback) {
    item.func = function(){
        callback(item.tag);
    };
}

// eslint-disable-next-line no-unused-vars
function interfaceBackPress() {

    Android.log("here!");

    if(adl.notifyBackPress()) {
        console.log("ADL handled");
        return;
    }

    if(isChatOpen()) {
        console.log("chat handled");
        closeChat();
        return;
    }

    if(appFrame != null && childWindowObject.webAppCore != null) {
        let backFunction = childWindowObject.webAppCore.onBack();
        Android.log("onBack return: " + backFunction);

        if(backFunction != "0"){
            Android.log("back handled");
            return;
        }
    }

    Android.log("no back function set");

    if(appFrame != null && currentFrameURL != window.appUrl && childWindowObject.webAppCore != null) {
        Android.log("going back");
        childWindowObject.webAppCore.goBack();
        sizeElements();
        return;
    }

    Android.log("cant navigate back");
    Android.doFinish();
}

function goPremium() {
    Android.goPremium();
}

// still needed for script.js, may change in future
function storeVar(key,value) {
    Android.saveVar(key,value.toString());
}

// still needed for script.js, may change in future
function getVar(key) {
    return Android.returnVar(key);
}

function toggleShareBox(value) {
    textToShare = value.replace("#appurl",window.shareURL);

    Android.nativeShare(textToShare);
}

// eslint-disable-next-line no-unused-vars
function vibrate(duration) {
    Android.vibratePhone(duration);
}

// eslint-disable-next-line no-unused-vars
function endVibrate() {
    Android.stopVibration();
}

// eslint-disable-next-line no-unused-vars
function setTheme(color) {
    lastTheme = color;

    let forceTheme = "dark";

    if(isSystemThemeDark()) {
        forceTheme = "dark";
    } else {
        forceTheme = "light";
    }

    adl.setTheme(color,forceTheme);
    Android.setTheme(color);

    let useTitleColor = "#ffffff";

    if(forceTheme == "dark") {
        useTitleColor = "#222222";
    }

    appWrapper.style.backgroundColor = useTitleColor;
    //chatHolder.style.backgroundColor = useTitleColor;

    rebuildToolbar();
}

// eslint-disable-next-line no-unused-vars
function processScreenshot(canvas,send) {
    let dataURL = canvas.toDataURL();

    if(!send) {
        send = false;
    }

    Android.saveScreenFromData(dataURL,send);

    showToast("Picture saved to Photos!");
}

// eslint-disable-next-line no-unused-vars
function shareImage(element) {
    let blob;

    if (element) {
        let elementType = element.tagName.toLowerCase();

        if (elementType == "img") {
            let cv = document.createElement("canvas");
            cv.width = element.width;
            cv.height = element.height;
            let ct = cv.getContext("2d");
            ct.drawImage(element, 0, 0,element.width,element.height);
            blob = cv.toDataURL();
            Android.saveScreenFromData(blob,true);
            return;
        }

        if (elementType == "canvas") {
            blob = element.toDataURL();
            Android.saveScreenFromData(blob,true);
            return;
        }
    } else {
        element = childWindowObject.document.body;
    }

    html2canvas(element, {
        allowTaint: true
    }).then(function(canvas) {
        let blob = canvas.toDataURL();
        Android.saveScreenFromData(blob,true);
    });
}

// eslint-disable-next-line no-unused-vars
function saveFile(filename,filecontent,blockCloud,callbackid,useDir) {

    console.log("DO SAVE");

    if(!useDir) {
        useDir = null;
    }

    if(typeof filecontent === "string") {
        console.log("string save");
        Android.saveFileWithCallbackid(filename,filecontent,blockCloud,callbackid,useDir);
        return;
    }

    if(typeof filecontent === "number") {
        console.log("number save");
        Android.saveFileWithCallbackid(filename,filecontent.toString(),blockCloud,callbackid,useDir);
        return;
    }

    let uInt8Array = new Uint8Array(filecontent);

    let arr = new Uint8Array(uInt8Array.length);

    for(let i = 0; i < uInt8Array.length; i++) {
        arr[i] = uInt8Array[i];
    }


    console.log("binary save");
    Android.saveFileBytesWithCallbackid(filename,arr,callbackid,useDir);
}

// eslint-disable-next-line no-unused-vars
function onSaveDone(callbackid) {
    if(childWindowObject.webAppCore) {
        childWindowObject.webAppCore.onFileSaveComplete(callbackid);
    }
}

// eslint-disable-next-line no-unused-vars
function getFiles(useDir) {

    if(!useDir) {
        useDir = null;
    }

    if(useDir && useDir.trim().length > 0) {
        Android.getFileListing(useDir);
        return;
    }

    let listing = Android.getFileListing(null);
    handleCompleteFileListingBack(listing);
}

function handleCompleteFileListingBack(listing) {

    console.log(listing);

    let retArray = [];
    let rawArray = listing.split("|");

    for(let i = 0; i < rawArray.length; i++) {
        if(rawArray[i].length > 0) {
            retArray[i] = rawArray[i];
        }
    }

    childWindowObject.webAppCore.listingLoaded(retArray);
}

function deleteFile(filename,useDir) {

    if(!useDir) {
        useDir = null;
    }

    Android.deleteFile(filename,useDir);
}

function loadURL(url) {
    Android.navigateExternal(url);
}

function doTTS(text) {
    Android.doTTS(text);
}

function stopTTS() {
    Android.stopTTS();
}

function wacOnTtsDone(string) {
    childWindowObject.webAppCore.onTTSdone(string);

}

function showToast(message,icon,actionButton) {

    let action = null;

    if(actionButton) {

        action = {
            text: actionButton.title,
            func: actionButton.callback
        };
    }

    adl.showToast({
        message: message,
        icon: getCleanIcon(icon),
        action: action
    });
}

function submitHighScore(modeid,score) {
    Android.submitHighScore(modeid.toString(),score.toString());
}

function prepareAchievementData() {
    // handled by external wrapper
}

function reportAchievement(trophy,increment) {

    if(!increment) {
        increment = 0;
    }

    Android.submitAchievement(trophy.toString(),increment);
}

function showAchievements() {
    Android.viewAchievements();
}

function setHighScoresUsername() {

}

function getHighScoresUsername() {

}

function getDailyTopScore(mode) {
    // hrmm
    /*
    if(scoreServerId === 'undefined') {
        return;
    }

    let scoreData = new Array();
    scoreData[scoreData.length] = {key:"g",value:scoreServerId};
    scoreData[scoreData.length] = {key:"m",value:mode};


    dataRequest("http://www.ape-apps.com/highscores/app_resource.php?f=2",processTopScoreResult,scoreData,true);
    */
}

function processTopScoreResult(data) {
    if (data.indexOf("###") == -1) {
        return;
    }

    let resultReadout = "Today's top score: " + data.replace("###"," - ");

    childWindowObject.webAppCore.setDailyReadout(resultReadout);
}

function toggleScores(mode) {
    Android.viewHighScores(mode.toString());
}

function clearPlatformSplash() {
    if (typeof Android.clearSplash == "function") {
        Android.clearSplash();
    }
}

function onInputFileSelected(e) {
    let f = e.target.files[0];

    if (f) {
        let r = new FileReader();
        r.onload = function(e) {
            let contents = e.target.result;
            let name = f.name.replace("'","");

            importComplete(name,contents);
        };

        if(f.name.toLowerCase().endsWith(".gb") || f.name.toLowerCase().endsWith(".gbc")) {
            r.readAsArrayBuffer(f);
        } else {
            r.readAsBinaryString(f);
        }
    } else {
        importComplete(null,null);
    }

    fileSelector.value = null;
}

// Web App Core 3.1 Hooks
function importLocalFile(type,asBinary) {

    if(!asBinary) {
        asBinary = false;
    }

    importIsBinary = asBinary;

    Android.importFile(type,asBinary);
}

let importIsBinary = false;

function wacListCallback(tag) {
    childWindowObject.webAppCore.nativeListOptionSelected(tag);
}

function notifyImportReady(fileId) {
    let name = Android.getImportName(fileId);
    let content;

    if(importIsBinary) {

        let binRaw = Android.getImportContentBinary(fileId);

        let contentStringArray = binRaw.split(",");

        console.log(contentStringArray.length);

        let uInt8Array = new Uint8Array(contentStringArray.length);

        for(let i = 0; i < contentStringArray.length; i++) {
            uInt8Array[i] = parseInt(contentStringArray[i]);
        }

        content = uInt8Array;

    } else {
        content = Android.getImportContent(fileId);
    }

    console.log(content);

    childWindowObject.webAppCore.fileImportComplete(name,content,fileId);
}

function importComplete(name,contents) {
    childWindowObject.webAppCore.fileImportComplete(name,contents);
}

function wacSliderCallback(val) {
}

function exportTextFileAsDialog(filename,content,isXML) {

    if(typeof content === "string") {
        console.log("string export");
        Android.exportFile(filename,content);
        return;
    }

    let uInt8Array = new Uint8Array(content);

    let arr = new Uint8Array(uInt8Array.length);

    for(let i = 0; i < uInt8Array.length; i++) {
        arr[i] = uInt8Array[i];
    }

    Android.exportFileBytes(filename,arr);
}

function sendFile(filename) {

    //console.log("send: " + filename);

    Android.sendFile(filename);
}

function copyToClipboard(text) {
    Android.copyText(text);
}

function getInterface() {
    return "android";
}

function isTV() {
    return Android.getIsTvDevice();
}

function printContent(content,margin) {

    if(!margin) {
        margin = "0.5in";
    }

    let fullHTML = "<!DOCTYPE html><html><head><style>@page{ margin: " + margin + "; } html,body{ color: #000000; background-color: #ffffff; margin: 0px; padding: 0px; } table{ page-break-after:auto; } tr,td{ page-break-inside:avoid; page-break-after:auto; } thead{ display:table-header-group; break-inside: avoid; } tfoot{ display:table-footer-group; }</style></head><body>" + content + "</body></html>";

    Android.printDocument(fullHTML);
}

function changeWorkingDirectory() {
    Android.moveWorkspace();
}

function workspaceChangeCallback(result) {
    childWindowObject.webAppCore.workspaceChanged(result);
}

let packSaveTimer;
let tmpPackageName;
let tmpPackageContent;

function updateVarPackage(pkg) {

    if(packSaveTimer) {
        clearTimeout(packSaveTimer);
    }

    tmpPackageContent = JSON.stringify(pkg);
    tmpPackageName = window.webAppId + "_var_package.wvp";

    packSaveTimer = setTimeout(function() {
        packSaveTimer = null;
        Android.saveFile(tmpPackageName,tmpPackageContent,true);
    },300);

}

let openFileCallback = null;

function openFile(name,callback,useDir) {

    if(!useDir) {
        useDir = null;
    }

    openFileCallback = callback;
    Android.openFile(name,useDir);
}

function onOpenFileReady() {
    if(openFileCallback != null) {
        openFileCallback(Android.getOpenedFile());
    }
}

function buildVarPackage() {

    let fileName = window.webAppId + "_var_package.wvp";

    openFile(fileName,continueVarPackage);

}

function wacFileReturn(content) {
    childWindowObject.webAppCore.onFileOpened(content);
}

function openFileFromWac(name,useDir) {
    openFile(name,wacFileReturn,useDir);
}

function continueVarPackage(content) {
	
    if(appFrame && childWindowObject.webAppCore) {
        if(content && content.trim().length > 0) {
            try {
                let obj = JSON.parse(content);
                childWindowObject.webAppCore.recieveVariablePackage(obj);
            } catch(ex) {
                childWindowObject.webAppCore.recieveVariablePackage({});
            }
			
        } else {
            childWindowObject.webAppCore.recieveVariablePackage({});
        }
    }
}

let startReportingShake = false;

function setShakeSensitivity(sensitivity) {
    startReportingShake = true;
    Android.setSensorActivation(true,sensitivity);
}

function sakeEventCallback() {
    if(startReportingShake) {
        if(childWindowObject.webAppCore.shakeCallback) {
            childWindowObject.webAppCore.shakeCallback();
        }
    }
}

function checkForLaunchFile() {
    let hasLaunchFile = Android.doesLaunchFileExist();

    if(childWindowObject.webAppCore.launchCheckCallback) {
        childWindowObject.webAppCore.launchCheckCallback(hasLaunchFile);
    } else {
        console.log("no launch callback!");
    }
}

let tmpPndLaunchFileName = null;

function getLaunchFileName() {
    tmpPndLaunchFileName = Android.getLaunchFileName();

    if(childWindowObject.webAppCore.launchNameCallback) {
        childWindowObject.webAppCore.launchNameCallback(tmpPndLaunchFileName);
    }
}

function getLaunchFileContent() {
    let launchFileContent;

    if(tmpPndLaunchFileName && (tmpPndLaunchFileName.endsWith(".gb") || tmpPndLaunchFileName.endsWith(".gbc"))) {
        let binRaw = Android.openLaunchFileBinary();

        let contentStringArray = binRaw.split(",");

        console.log(contentStringArray.length);

        let uInt8Array = new Uint8Array(contentStringArray.length);

        for(let i = 0; i < contentStringArray.length; i++) {
            uInt8Array[i] = parseInt(contentStringArray[i]);
        }

        launchFileContent = uInt8Array;
    } else {
        //launchFileContent = Android.openLaunchFile();

        childWindowObject.webAppCore.launchContentCallback(Android.openLaunchFile().replace(/[\x00-\x1F\x7F]/g, ""));
        return;
    }

    if(childWindowObject.webAppCore.launchContentCallback) {
        childWindowObject.webAppCore.launchContentCallback(launchFileContent);
    }
}

function saveLaunchFile(content) {
    Android.saveLaunchFile(content);
}

function onGeneralError(e) {
    let appVersion = Android.getAppVersion();
    let scrpt = e.filename.substr(e.filename.lastIndexOf("/") + 1);

    Android.trackEvent("Android Web Frame Error " + appVersion,scrpt + ":" + e.lineno,e.message, false);
    Android.logError(scrpt, e.lineno.toString(), e.message);
}

function onFrameError(e) {
    let appVersion = Android.getAppVersion();
    let scrpt = e.filename.substr(e.filename.lastIndexOf("/") + 1);

    Android.trackEvent("Android Webapp Error " + appVersion,scrpt + ":" + e.lineno,e.message, false);
    Android.logError(scrpt, e.lineno.toString(), e.message);
}

let audioArray;
let loopingAudio;
let audioType = "ogg";

function playAudio(soundname) {
    let soundFileURL = "app/audio/" + audioType + "/" + soundname + "." + audioType;
    playAudioChannel(soundFileURL,0);
}

function playAudioChannel(soundName,channel) {

    if(!audioArray[channel]) {
        audioArray[channel] = [];
    }

    let arrayToUse = audioArray[channel];

    let audioObject;

    for(let i = 0; i < arrayToUse.length; i++) {
        if(arrayToUse[i].name == soundName) {
            audioObject = arrayToUse[i];
        }
    }

    if(audioObject) {
        if(audioObject.audObj.currentTime > 0) {
            playAudioChannel(soundName,(channel + 1));
            return;
        }
        audioObject.audObj.play();
    } else {
        let myAudio = document.createElement("audio");
        myAudio.src = soundName;
        myAudio.addEventListener("ended",function(e) {
            this.currentTime = 0;
        },false);
        myAudio.play();

        audioObject = { name:soundName,audObj:myAudio };

        arrayToUse.push(audioObject);
    }
}

function loopAudio(soundname) {
    let soundFileURL = "app/audio/" + audioType + "/" + soundname + "." + audioType;

    loopingAudio.src = soundFileURL;
    loopingAudio.loop = true;
    loopingAudio.play();
}

function killLoop() {
    loopingAudio.pause();
    loopingAudio.src = "";
    try {
        loopingAudio.currentTime = 0;
    } catch(err) {
        // whatevs
        ga("send", "exception", {
            "exDescription": err.message,
            "exFatal": false
        });
    }
}

function wacSoundInstanceDone(soundName) {
    if(childWindowObject.webAppCore.audioInstanceCallbackListener) {
        childWindowObject.webAppCore.audioInstanceCallbackListener(soundName);
    }
}

function wacRewardDone(status) {
    if(childWindowObject.webAppCore.rewardedVideoDone) {
        childWindowObject.webAppCore.rewardedVideoDone(status);
    }
}

function wacNativeGetBack(id,data) {
    if(childWindowObject.webAppCore.nativeGetBack) {
        childWindowObject.webAppCore.nativeGetBack(id,data);
    }
}

function wacTcpSocketConnected(id,cbid) {
    if(childWindowObject.webAppCore.onSocketConnected) {
        childWindowObject.webAppCore.onSocketConnected(id,cbid);
    }
}

function wacTcpSocketCreated(id) {
    if(childWindowObject.webAppCore.onSocketCreated) {
        childWindowObject.webAppCore.onSocketCreated(id);
    }
}

function wacRecieveSocketMessage(id,message,tag) {
    if(childWindowObject.webAppCore.onTcpSocketMessage) {
        childWindowObject.webAppCore.onTcpSocketMessage(id,message,tag);
    }
}

function wacAllPortsScanDone() {
    console.log("all ports done!");

    let raw = Android.returnAllPorts();
    console.log(raw);

    let ports = JSON.parse(raw);

    if(childWindowObject.webAppCore.onPortScanComplete) {
        childWindowObject.webAppCore.onPortScanComplete(ports);
    }
}

function tryToGetRemoteIpAndLocation() {
    dataRequest("http://ip-api.com/json",onLocationDataBack,null,false);
}

function onLocationDataBack(data) {
    if(data) {
        try {
            let jsonData = JSON.parse(data);
            remoteip = jsonData.query;
            return;
        } catch(ex) {
            console.log(ex);
        }
    }
}

// eslint-disable-next-line no-unused-vars
function getRemoteIp() {
    return remoteip;
}

// eslint-disable-next-line no-unused-vars
function recieveIntervalLocationData(lat,lon,alt,deg,mps) {
    let locdata = {
        "lat": lat,
        "lon": lon,
        "alt": alt,
        "deg": deg,
        "mps": mps
    };

    if(appFrame && childWindowObject && childWindowObject.webAppCore && childWindowObject.webAppCore.onLocationIntervalBack) {
        childWindowObject.webAppCore.onLocationIntervalBack(locdata);
    }
}

// eslint-disable-next-line no-unused-vars
function recieveLocationData(lat,lon,alt,deg,mps) {
    let locdata = {
        "lat": lat,
        "lon": lon,
        "alt": alt,
        "deg": deg,
        "mps": mps
    };

    if(childWindowObject.webAppCore.onLocationBack) {
        childWindowObject.webAppCore.onLocationBack(locdata);
    }
}

let locationWasRetried = false;

function tryLocationOneMoreTime() {
    if(!locationWasRetried) {
        Android.getCurrentLocation();
    }

    locationWasRetried = true;
}

function wacCustomSongPicked(name) {
    if(!appFrame || !childWindowObject.webAppCore) {
        return;
    }

    if(childWindowObject.webAppCore.onPickedCustomSong) {
        childWindowObject.webAppCore.onPickedCustomSong(name);
    }
}

function gotCameraPermission() {

    if(!appFrame || !childWindowObject.webAppCore) {
        return;
    }

    if(childWindowObject.webAppCore.onGotCameraPermission) {
        childWindowObject.webAppCore.onGotCameraPermission();
    }
}

function wacEditedImageBack(data) {
    if(!appFrame || !childWindowObject.webAppCore) {
        return;
    }

    if(childWindowObject.webAppCore.onImageEdited) {
        childWindowObject.webAppCore.onImageEdited(data);
    }
}

function wacApeAppsLoginStatusChange(logged) {

    if(!appFrame || !childWindowObject.webAppCore) {
        return;
    }

    if(childWindowObject.webAppCore.onApeAppsStatusChanged) {
        childWindowObject.webAppCore.onApeAppsStatusChanged(logged);
    }

    if(logged) {
        connectToFriendsSignalingServer();
    } else {
        closeSignalSocketConnection();
    }

    rebuildToolbar();
}

// eslint-disable-next-line no-unused-vars
function loadChat(room,nametag,silent) {

    if(!silent) {
        silent = false;
    }

    if(!Android.isApeAppsLoggedIn()) {
        return;
    }

    if(!chatiFrame) {
        chatiFrame = document.createElement("iframe");
        chatiFrame.seamless = true;
        chatiFrame.className = "chatIframe";
        chatHolderFrame.appendChild(chatiFrame);

        chatHolderToolbar.innerHTML = "";

        let toolbarItems = [];

        toolbarItems.push({
            type: "button",
            special: "hamburger",
            menu: {
                items: [
                    {
                        title: "Help",
                        func: function(){
                            chatiFrame.contentWindow.postMessage({
                                "msg": "/help",
                                "data": "postchat"
                            },"*");
                        }
                    },
                    {
                        title: "Text Color",
                        func: function(){
                            adl.pickColor({
                                callback: function(color){ 
                                    if(color && color.trim().length == 7) {
                                        chatiFrame.contentWindow.postMessage({
                                            "msg": "/color " + color,
                                            "data": "postchat"
                                        },"*");
                                    }
                                } 
                            });
                        }
                    }
                ]
            }
        });

        toolbarItems.push({
            type: "spacer"
        });

        if(window.innerWidth > 500) {
            toolbarItems.push({
                type: "button",
                label: "Detach",
                icon: "resize-outline",
                func: function(){
                    closeChat();
                    window.open("https://chat.ape-apps.com/?channel=" + currentChatRoom,"apechat","resizable,height=800,width=1280");
                }
            });
        }

        toolbarItems.push({
            type: "button",
            label: "Dismiss",
            icon: "close-outline",
            func: function(){
                closeChat();
            }
        });

        let chatToolbarOptions = {
            element: chatHolderToolbar,
            forceLabel: true,
            items: toolbarItems
        };

        adl.addToolbar(chatToolbarOptions);
    }

    if(room != currentChatRoom) {
        let forceTheme = "dark";

        if(isSystemThemeDark()) {
            forceTheme = "dark";
        } else {
            forceTheme = "light";
        }

        let fg = "000000";

        if(forceTheme == "dark") {
            fg = "ffffff";
            chatHolder.style.backgroundColor = "#222222";
        } else {
            chatHolder.style.backgroundColor = "#ffffff";
        }

        currentChatRoom = room;

        if(nametag && nametag != "0" && nametag.trim().length > 1) {
            chatiFrame.src = "https://chat.ape-apps.com/?embed=1&channel=" + currentChatRoom + "&nametag=" + encodeURIComponent(nametag) + "&fh=" + fg;
        } else {
            chatiFrame.src = "https://chat.ape-apps.com/?embed=1&channel=" + currentChatRoom + "&fh=" + fg;
        }
    }
    

    if(!silent) {
        chatHolder.style.width = "290px";
    }

    
}

// eslint-disable-next-line no-unused-vars
function androidCredXferForChat(a,b,c,am) {
    if(chatiFrame != null) {
        chatiFrame.contentWindow.androidCredXfer(a,b,c,am);
    }
}

// eslint-disable-next-line no-unused-vars
function isChatOpen() {
    if(chatHolder.style.width == "290px") {
        return true;
    }

    return false;
}

function closeChat() {
    chatHolder.style.width = "0px";
}


// eslint-disable-next-line no-unused-vars
function onChatMessageReciever(dataString) {

    let obj = JSON.parse(dataString);

    if(childWindowObject && childWindowObject.webAppCore && childWindowObject.webAppCore.onChatMessage) {
        childWindowObject.webAppCore.onChatMessage(obj);
    }
}

function notifySaveImportDataDone(result) {
    if(childWindowObject && childWindowObject.webAppCore && childWindowObject.webAppCore.notifySaveImportDataDone) {
        childWindowObject.webAppCore.notifySaveImportDataDone(result);
    }
}

function notifySaveAsDone(id,filename) {

    console.log("SAVE AS DONE");

    if(childWindowObject && childWindowObject.webAppCore && childWindowObject.webAppCore.notifySaveAsDone) {
        childWindowObject.webAppCore.notifySaveAsDone(id,filename);
    }
}

/*
function wacSliderCallback(val) {
    if(appFrame && childWindowObject.webAppCore && childWindowObject.webAppCore.wacSliderCallback) {
        childWindowObject.webAppCore.wacSliderCallback(val);
    }
}*/

function isSystemThemeDark() {
    return Android.getSystemDark();
}

function getFriendsList() {
    let creds = JSON.parse(Android.getApeAppsCreds());
    let apeMarketId = Android.getApeMarketId();

    if(!creds) {
        console.log("no creds");
        return;
    }

    let statusData = [];

    statusData.push({
        "key": "f",
        "value": "9"
    });

    statusData.push({
        "key": "s1",
        "value": creds.a
    });

    statusData.push({
        "key": "s2",
        "value": creds.b
    });

    statusData.push({
        "key": "ak",
        "value": creds.c
    });

    statusData.push({
        "key": "apikey",
        "value": creds.c
    });

    statusData.push({
        "key": "am",
        "value": apeMarketId
    });

    dataRequest("https://accounts.ape-apps.com/api.php",onFriendsListBack,statusData,true);
}

function onFriendsListBack(data) {
    console.log(data);

    if(appFrame && childWindowObject.webAppCore && childWindowObject.webAppCore.onFriendsListReturn) {

        if(data) {
            try {
                let datObj = JSON.parse(data);
                console.log(datObj);
                childWindowObject.webAppCore.onFriendsListReturn(datObj);
            } catch(ex) {
                childWindowObject.webAppCore.onFriendsListReturn(null);
            }
        } else {
            childWindowObject.webAppCore.onFriendsListReturn(null);
        }


    } else {
        console.log(window.appFrame);
    }
}

function addFriend(username) {
    let creds = JSON.parse(Android.getApeAppsCreds());
    let apeMarketId = Android.getApeMarketId();

    if(!creds) {
        console.log("no creds");
        return;
    }

    let statusData = [];

    statusData.push({
        "key": "f",
        "value": "8"
    });

    statusData.push({
        "key": "s1",
        "value": creds.a
    });

    statusData.push({
        "key": "s2",
        "value": creds.b
    });

    statusData.push({
        "key": "ak",
        "value": creds.c
    });

    statusData.push({
        "key": "apikey",
        "value": creds.c
    });

    statusData.push({
        "key": "am",
        "value": apeMarketId
    });

    statusData.push({
        "key": "un",
        "value": username
    });

    dataRequest("https://accounts.ape-apps.com/api.php",onFriendAddedCallback,statusData,true);
}

function onFriendAddedCallback(data) {
    console.log(data);

    if(appFrame && childWindowObject.webAppCore && childWindowObject.webAppCore.onFriendAdded) {
        if(data) {
            childWindowObject.webAppCore.onFriendAdded(data);
        } else {
            childWindowObject.webAppCore.onFriendAdded("-1");
        }
    }
}

function wacChatLoadProfile(username) {
    if(username && username.trim().length > 1) {
        if(appFrame && childWindowObject.webAppCore && childWindowObject.webAppCore.onChatUsernameSelected) {
            childWindowObject.webAppCore.onChatUsernameSelected(username.trim());
        }

    }
}

function closeSignalSocketConnection() {
    if(!Android.isApeAppsLoggedIn()) {

        if(signalSocket) {
            signalSocket.emit("closeconnection","");
            signalSocket.close();
        }

        signalSocket = null;
        signalSocketConnected = false;

        return;
    }

    let profile = getApeAppsProfile();

    if(!profile) {
        return;
    }


    if(signalSocket) {
        signalSocket.emit("gamemessage",{
            "destination": "awa-friends-signaling-" + profile.un,
            "msg": {
                "type": "friendsignal",
                "code": "goingoffline",
                "un": profile.un,
                "for": "all"
            }
        });

        signalSocket.emit("closeconnection","");
        signalSocket.close();
    }

    signalSocket = null;
    signalSocketConnected = false;
}

function onSignalSocketMessage(message) {

    if(!message || !message.type || message.type != "friendsignal") {
        return;
    }

    if(!Android.isApeAppsLoggedIn()) {
        return;
    }

    let me = getApeAppsProfile();

    if(message.code == "customsignal") {
        if(childWindowObject && childWindowObject.webAppCore && childWindowObject.webAppCore.onCustomSignalMessage) {
            childWindowObject.webAppCore.onCustomSignalMessage(message.from,message.data);
        }
    }

    if(message.code == "onlinecheck") {
        updateFriendsNetworkStatus(lastFriendsStatus);
    }

    if(message.code == "iamonline" && message.un) {
        setFriendStatus(message.un,true,null);
    }

    if(message.code == "iamplaying" && message.un) {
        setFriendStatus(message.un,true,message.extra);
    }

    if(message.code == "goingoffline" && message.un) {
        setFriendStatus(message.un,false,null);
    }
}

function setFriendStatus(friend,online,extra) {

    let previouslyOnline = false;
    let onThisApp = false;

    if(!friendOnlineStatus[friend]) {
        friendOnlineStatus[friend] = {};
    }

    if(friendOnlineStatus[friend].ex && friendOnlineStatus[friend].ex.app == window.appName) {
        onThisApp = true;
    }

    if(friendOnlineStatus[friend].ol) {
        previouslyOnline = true;
    }

    if(!extra) {
        extra = null;
    }

    if(extra && extra.app == window.appName) {
        onThisApp = true;
    }

    friendOnlineStatus[friend].un = friend;
    friendOnlineStatus[friend].ol = online;

    if(!online || extra || !friendOnlineStatus[friend].ex) {
        friendOnlineStatus[friend].ex = extra;
    }

    if(!previouslyOnline) {
        let me = getApeAppsProfile();

        if(friend != me.un) {
            console.log(friend + " is online");
        }
    }

    if(onThisApp) {
        let sendStatus = null;

        if(online) {
            sendStatus = "online";

            if(extra && extra.stat) {
                sendStatus = extra.stat;
            }
        } else {
            sendStatus = "offline";
        }

        if(sendStatus) {
            if(childWindowObject && childWindowObject.webAppCore && childWindowObject.webAppCore.onFriendStatusUpdate) {
                childWindowObject.webAppCore.onFriendStatusUpdate(friend,sendStatus);
            }
        }
    }
}

function connectToFriendsSignalingServer() {
    if(!Android.isApeAppsLoggedIn()) {
        console.log("not logged in");
        return;
    }

    if(signalSocket || signalSocketConnected) {
        return;
    }

    signalSocket = io("https://signaling.ape-apps.com:2736",{
        secure: true,
        rejectUnauthorized: false
    });

    signalSocket.on("connect",onSignalSocketConnect);
    signalSocket.on("message",onSignalSocketMessage);
    signalSocket.on("disconnect",onSignalSocketDisconnect);
}

function updateFriendsNetworkStatus(status) {

    let profile = getApeAppsProfile();

    if(!profile || !signalSocket) {
        return;
    }

    signalSocket.emit("gamemessage",{
        "destination": "awa-friends-signaling-" + profile.un,
        "msg": {
            "type": "friendsignal",
            "code": "iamplaying",
            "un": profile.un,
            "extra": {
                "app": Android.getAppName(),
                "plat": Android.getPlatform(),
                "stat": status
            },
            "for": "all"
        }
    });
}

function onSignalSocketDisconnect() {
    signalSocketConnected = false;
}

function onSignalSocketConnect() {
    let profile = getApeAppsProfile();

    if(!profile || !signalSocket) {
        return;
    }

    signalSocketConnected = true;

    signalSocket.emit("joinroom","awa-friends-signaling-" + profile.un);

    announceOnlineToSignalServer();
}

function announceOnlineToSignalServer() {

    if(!signalSocket) {
        return;
    }

    announceCurrentOnlineStatus();
    updateFriendsNetworkStatus(null);
    joinFriendsSignalChannels();
}

function announceCurrentOnlineStatus() {
    if(!signalSocket) {
        return;
    }

    let profile = getApeAppsProfile();

    signalSocket.emit("gamemessage",{
        "destination": "awa-friends-signaling-" + profile.un,
        "msg": {
            "type": "friendsignal",
            "code": "iamonline",
            "un": profile.un,
            "for": "all"
        }
    });
}

function joinFriendsSignalChannels() {

    if(!signalSocket) {
        return;
    }

    let creds = JSON.parse(Android.getApeAppsCreds());
    let apeMarketId = Android.getApeMarketId();

    if(!creds) {
        return;
    }

    let statusData = [];

    statusData.push({
        "key": "f",
        "value": "9"
    });

    statusData.push({
        "key": "s1",
        "value": creds.a
    });

    statusData.push({
        "key": "s2",
        "value": creds.b
    });

    statusData.push({
        "key": "ak",
        "value": creds.c
    });

    statusData.push({
        "key": "apikey",
        "value": creds.c
    });

    statusData.push({
        "key": "am",
        "value": apeMarketId
    });

    dataRequest("https://accounts.ape-apps.com/api.php",function(data){
        try {
            let friendsObj = JSON.parse(data);

            if(friendsObj.confirmed && friendsObj.confirmed.length > 0) {
                for(let i = 0, l = friendsObj.confirmed.length; i < l; i++) {
                    let friend = friendsObj.confirmed[i];

                    let chRef = "awa-friends-signaling-" + friend.un;

                    if(signalSocket) {
                        signalSocket.emit("joinroom",chRef);
                    }
                }
            }
        } catch(ex) {
            console.log(ex);
        }

        let me = getApeAppsProfile();

        if(signalSocket && me) {
            signalSocket.emit("gamemessage",{
                "destination": "awa-friends-signaling-" + me.un,
                "msg": {
                    "type": "friendsignal",
                    "code": "onlinecheck",
                    "for": "all"
                }
            });
        }

    },statusData,true,true);
}

function getApeAppsProfile() {

    let profileString = Android.getApeAppsProfile();

    let proBack = null;

    if(profileString != null) {
        proBack = JSON.parse(profileString);
    }

    return proBack;

}

function rebuildToolbar() {

    toolbarHolder.innerHTML = "";
    bottomToolbarHolder.innerHTML = "";

    let tbBackground = null;
    let tbForeground = null;

    if(!lastTheme) {
        lastTheme = "#009688";
    }

    tbBackground = lastTheme;

    if(adl.isHexColorDark(tbBackground)) {
        tbForeground = "#ffffff";
    } else {
        tbForeground = "#000000";
    }

    /*
    if(window.themeStyle == "2" || window.themeStyle == "3") {
        tbBackground = lastTheme;

        if(adl.isHexColorDark(tbBackground)) {
            tbForeground = "#ffffff";
        } else {
            tbForeground = "#000000";
        }
    }
    */

    if(!window.useToolbar) {
        return;
    }

    let secondaryToolbarItems = [];
    let primaryToolbarItems = [];

    for(let i = 0; i < customToolbar.length; i++) {
        let item = customToolbar[i];

        if(item.wacInSecondary) {
            secondaryToolbarItems.push(item);
        } else {
            primaryToolbarItems.push(item);
        }
    }

    let accountButton = null;
    let premiumOption = null;
    let categoryOption = null;

    if(sidebarCategory) {

        let sbIcon = "list-outline";

        if(sidebarCategoryIcon) {
            sbIcon = getCleanIcon(sidebarCategoryIcon);
        }

        categoryOption = {
            title: sidebarCategory,
            icon: sbIcon,
            func: showCategoriesFromSidebar
        };
    } else {
        let sbIcon = "list-outline";


        categoryOption = {
            title: "Latest Updates",
            icon: sbIcon,
            func: showCategoriesFromSidebar
        };
    }

    if(!getIsPremium()) {
        premiumOption = {
            title: premiumText,
            icon: "cart-outline",
            func: goPremium
        };
    }

    

    if(Android.isApeAppsLoggedIn()) {

        let apeProfile = getApeAppsProfile();

        accountButton = {
            type: "button",
            label: apeProfile.un,
            icon: "https://accounts.ape-apps.com/getavatar.php?u=" + apeProfile.un,
            circleIcon: true,
            func: showProfileOptions
            
        };
    } else {
        accountButton = {
            type: "button",
            label: "Sign In",
            icon: "person-circle-outline",
            func: function(){
                Android.showApeLogin();
            }
        };
    }



    let toolbarOptions = {
        element: toolbarHolder,
        items: [],
        background: tbBackground,
        foreground: tbForeground
    };

    let customHelpOptions = 0;

    if(window.innerWidth > 500) {

        let customMenuCategories = [];
        let customMenuItems = {};

        customMenuCategories.push("File");
        customMenuItems.File = [];

        customMenuCategories.push("Edit");
        customMenuItems.Edit = [];


        for(let i = 0; i < customMenu.length; i++) {
            let cm = customMenu[i];

            if(cm.wacSubmenu) {
                if(customMenuCategories.indexOf(cm.wacSubmenu) == -1) {
                    if(cm.wacSubmenu != "View" && cm.wacSubmenu != "Help") {
                        customMenuCategories.push(cm.wacSubmenu);
                    }

                }
            } else {
                cm.wacSubmenu = "File";
            }

            if(!customMenuItems[cm.wacSubmenu]) {
                customMenuItems[cm.wacSubmenu] = [];
            }

            customMenuItems[cm.wacSubmenu].push(cm);

            if(cm.wacSubmenu == "Help") {
                customHelpOptions++;
            }
        }

        if(customMenuCategories.indexOf("View") == -1) {

            customMenuCategories.push("View");

            if(!customMenuItems.View) {
                customMenuItems.View = [];
            }

        }

        if(customMenuCategories.indexOf("Help") == -1) {
            customMenuCategories.push("Help");

            if(!customMenuItems.Help) {
                customMenuItems.Help = [];
            }
        }

        if(customMenuItems.View.length > 0) {
            customMenuItems.View.push({
                type: "separator"
            });
        }

        if(premiumText) {

            if(customMenuItems.Help.length > 0) {
                customMenuItems.Help.unshift({
                    type: "separator"
                });
                customMenuItems.Help.unshift(premiumOption);
            } else {
                customMenuItems.Help.push(premiumOption);
            }

        }

        if(customHelpOptions > 0) {
            customMenuItems.Help.push({
                type: "separator"
            });
        }

        if(categoryOption) {
            customMenuItems.Help.push(categoryOption);
        }

        customMenuItems.Help.push({
            title: "Share " + window.appName,
            func: performStandardShare,
            icon: "share-social-outline"
        });

        customMenuItems.Help.push({
            title: "Send Feedback",
            func: presentFeedbackWindow,
            icon: "mail-outline"
        });

        customMenuItems.Help.push({
            title: "About " + window.appName,
            func: presentAbout,
            icon: "information-circle-outline"
        });

        for(let i = 0; i < customMenuCategories.length; i++) {
            let cat = customMenuCategories[i];

            if(!customMenuItems[cat] || customMenuItems[cat].length == 0) {
                continue;
            }

            toolbarOptions.items.push({
                type: "button",
                label: cat,
                menu: {
                    items: customMenuItems[cat]
                }
            });
        }

        toolbarOptions.items.push({
            type: "spacer"
        });



        if(primaryToolbarItems) {

            let added = 0;
            let totalToAdd = 1;

            if(window.innerWidth > 620) {
                totalToAdd = 2;
            }

            while(primaryToolbarItems.length > 0) {

                let item = primaryToolbarItems.shift();

                if(added < totalToAdd) {
                    toolbarOptions.items.push({
                        type: "button",
                        label: item.title,
                        icon: item.icon,
                        func: item.func
                    });
                } else {
                    secondaryToolbarItems.push(item);
                }

                added++;
            }
        }

        if(accountButton) {
            toolbarOptions.items.push(accountButton);
        }

        if(secondaryToolbarItems && secondaryToolbarItems.length > 0) {
            toolbarOptions.items.push({
                type: "button",
                special: "threedots",
                menu: {
                    items: secondaryToolbarItems
                }
            });
        }

    } else {

        if(accountButton) {
            toolbarOptions.items.push(accountButton);
        }

        let dropdownOptions = [];
        let needsSep = true;

        if(customMenu) {
            for(let i = 0; i < customMenu.length; i++) {
                dropdownOptions.push(customMenu[i]);
            }

            if(dropdownOptions.length > 0) {
                dropdownOptions.push({
                    type: "separator"
                });

                needsSep = false;
            }
        }

        if(secondaryToolbarItems.length > 0) {

            while(secondaryToolbarItems.length > 0) {
                dropdownOptions.push(secondaryToolbarItems.shift());
            }


            dropdownOptions.push({
                type: "separator"
            });

            needsSep = false;
        }

        if(dropdownOptions.length > 0 && needsSep) {
            dropdownOptions.push({
                type: "separator"
            });
        }

        if(premiumText && premiumOption) {
            dropdownOptions.push(premiumOption);
        }

        // default menu items 
        if(sidebarCategory) {
            let sbIcon = "list-outline";

            if(sidebarCategoryIcon) {
                sbIcon = getCleanIcon(sidebarCategoryIcon);
            }

            dropdownOptions.push({
                title: sidebarCategory,
                icon: sbIcon,
                func: showCategoriesFromSidebar
            });
        } else {
            let sbIcon = "list-outline";

            dropdownOptions.push({
                title: "Latest Updates",
                icon: sbIcon,
                func: showCategoriesFromSidebar
            });

        }

        dropdownOptions.push({
            title: "Share " + window.appName,
            func: performStandardShare,
            icon: "share-social-outline"
        });

        dropdownOptions.push({
            title: "Send Feedback",
            func: presentFeedbackWindow,
            icon: "mail-outline"
        });

        dropdownOptions.push({
            title: "About " + window.appName,
            func: presentAbout,
            icon: "information-circle-outline"
        });

        if(!currentTitle) {
            currentTitle = Android.getAppName();
        }

        let text = currentTitle;


        toolbarOptions.items.push({
            type: "title",
            label: text
        });

        toolbarOptions.items.push({
            type: "button",
            special: "threedots",
            menu: {
                items: dropdownOptions
            }
        });


    }

    adl.addToolbar(toolbarOptions);

    if(primaryToolbarItems && primaryToolbarItems.length > 0) {

        let bottomToolbarOptions = {
            element: bottomToolbarHolder,
            items: [],
            background: tbBackground,
            foreground: tbForeground
        };

        if(window.innerWidth > 500 || primaryToolbarItems.length > 5) {
            bottomToolbarOptions.items.push({
                type: "spacer"
            });
        }

        let added = 0;

        while(primaryToolbarItems.length > 0) {

            let item = primaryToolbarItems.shift();

            if(added > 5) {
                secondaryToolbarItems.push(item);
            } else {
                bottomToolbarOptions.items.push({
                    type: "button",
                    label: item.title,
                    icon: item.icon,
                    func: item.func
                });
            }

        }

        if(secondaryToolbarItems && secondaryToolbarItems.length > 0) {
            bottomToolbarOptions.items.push({
                type: "button",
                special: "threedots",
                menu: {
                    items: secondaryToolbarItems
                }
            });
        }

        adl.addToolbar(bottomToolbarOptions);
    }

}

// eslint-disable-next-line no-unused-vars
function setSidebarCategory(cat,icon) {
    sidebarCategory = cat;
    
    if(icon) {
        sidebarCategoryIcon = icon;
    } else {
        sidebarCategoryIcon = null;
    }

    rebuildToolbar();
}

// eslint-disable-next-line no-unused-vars
function showDialog(options) {
    if(!options.list) {
        options.list = [];
    }

    if(options.icon) {
        options.icon = getCleanIcon(options.icon);
    }

    if(options.sliderCallback) {
        options.slider = {
            min: options.sliderMin,
            max: options.sliderMax,
            value: options.sliderValue,
            status: options.sliderStatusText,
            onChange: options.sliderCallback
        };
    }

    if(options.listItems) {

        // clean up items 
        for(let i = 0; i < options.listItems.length; i++) {
            let item = options.listItems[i];

            if(item["status-color"]) {
                item.statusColor = item["status-color"];
            }

            item.icon = getCleanIcon(item.icon);

            if(item.overflow) {
                for(let j = 0; j < item.overflow.length; j++) {
                    let of = item.overflow[j];
                    if(of.icon) {
                        of.icon = getCleanIcon(of.icon);
                    }
                }
            }
        }

        adl.showList({
            title: options.title,
            options: options.listItems,
            onSelection: function(tag) {
                options.listCallback(tag);
            }
        });

        return;
    }

    adl.showDialog(options);
}

function showChoice(message,option1,option2) {
    adl.showChoice(message, option1, option2, sendChoiceOne, sendChoiceTwo);
}

function sendChoiceOne() {
    childWindowObject.webAppCore.choice1();
}

function sendChoiceTwo() {
    childWindowObject.webAppCore.choice2();
}

function showCategoriesFromSidebar() {
    let data = [];

    if(sidebarCategory != null) {
        data.push({
            "key":  "cat",
            "value": sidebarCategory
        });
    }

    dataRequest("https://market.ape-apps.com/app_resources/get-category.php",onCatDataBack,data,true);
}

function replaceAll(str, find, replace) {
    return str.replace(new RegExp(find, "g"), replace);
}

function onCatDataBack(data) {
    if(!data || data.trim().length == 0) {
        return;
    }

    let thisPlat = Android.getPlatform();

    try {
        let catData = JSON.parse(data);
        
        let varItems = [];

        for(let i = 0; i < catData.length; i++) {
            if(sidebarCategory == null && varItems.length >= 6) {
                break;
            }

            let dat = catData[i];

            let useDesc = dat.description.split("<br />")[0];

            let useLink = "https://market.ape-apps.com/app.php?app=" + replaceAll(dat.app_name.toLowerCase()," ","-") + ".html";

            if(thisPlat == "2") {
                if(dat.androidmarket && dat.androidmarket != "0" && dat.androidmarket != "n/a") {
                    useLink = "market://details?id=" + dat.androidmarket;
                } else {
                    useLink = null;
                }
            }

            if(thisPlat == "3") {
                if(dat.amazon_market && dat.amazon_market != "0" && dat.amazon_market != "n/a") {
                    useLink = "https://www.amazon.com/gp/mas/dl/android?p=" + dat.amazon_market;
                } else {
                    useLink = null;
                }
            }

            if(!useLink) {
                continue;
            }


            let catItrm = {
                "title": dat.app_name,
                "description": useDesc,
                "icon": "https://market.ape-apps.com/app_icons/" + dat.icon,
                "tag": useLink
            };

            if(thisPlat == "2") {
                catItrm.status = "Download from Google Play";
                catItrm.statusColor = "#388E3C";
            }


            varItems.push(catItrm);
        }

        let catTitle = "Recently Updated Apps";

        if(sidebarCategory != null) {
            catTitle = sidebarCategory;
        }

        let position = "right";

        if(window.innerWidth <= 500) {
            position = "bottom";
        }

        adl.showList({
            title: catTitle,
            options: varItems,
            onSelection: function(tag) {

                if(tag) {
                    onCatItemSelected(tag);
                }
            },
            flyout: {
                position: position
            }
        });
    } catch(ex) {
        console.log(ex);
    }
}

function onCatItemSelected(item) {
    if(!item || item.trim().length < 4) {
        return;
    }

    loadURL(item);
}

// eslint-disable-next-line no-unused-vars
function setPremiumText(text) {
    if(text) {
        premiumText = text;
    } else {
        premiumText = "Remove Advertising";
    }

    rebuildToolbar();
}

function presentAbout() {
    let data = [];

    data.push({
        "key": "f",
        "value": "3"
    });

    data.push({
        "key": "un",
        "value": "bastecklein"
    });

    dataRequest("https://tokens.ape-apps.com/api.php",finishABoutPresentation,data,false,false);
}

function finishABoutPresentation(data) {
    let resultObject = null;

    try {
        let tmpResult = JSON.parse(data);
        resultObject = tmpResult[0];
    } catch(ex) {
        console.log(ex);
        resultObject = null;
    }

    if(resultObject == null) {
        return;
    }

    let urlBuild = "https://tokens.ape-apps.com/gettoken.php?s=72&f=37&p=" + resultObject.token;


    let aboutData = [];

    aboutData.push({
        "title": Android.getAppName() + " v" + Android.getAppVersion(),
        "icon": "https://market.ape-apps.com/app_resources/geticon.php?a=" + replaceAll(Android.getAppName().toLowerCase()," ","-"),
        "description": "Powered by Web App Core v" + Android.getWacVersion() + " for Android by Ape Apps.",
        "tag": "metainfo"
    });

    aboutData.push({
        "title": "Privacy Policy",
        "icon": "https://www.apewebapps.com/images/privacy.png",
        "description": "Ape Apps cares about your privacy.  Read the " + Android.getAppName() + " Privacy Policy online.",
        "status": "https://apps.ape-apps.com/" + replaceAll(Android.getAppName().toLowerCase()," ","-") + "/privacy.html",
        "statusColor": "#1976D2",
        "tag": "privacy"
    });

    aboutData.push({
        "title": "Developer",
        "icon": urlBuild,
        "description": Android.getAppName() + " was created and developed by Brandon Stecklein, doing business as Ape Apps.  Operating out of eastern Kansas, Brandon founded Ape Apps in the summer of 2010 and has been running the business full-time since 2012.  He has published games and apps for most major platforms, including Android, iOS, Windows, Mac, Linux, and the Web.",
        "tag": "developer"
    });

    aboutData.push({
        "title": "Support Community",
        "icon": "https://www.apewebapps.com/images/ape-apps-128.png",
        "description": "Ape Apps operates a global support forum community where you can get answers to many issues and questions you may have, or share your knowledge with others!  Check it out!",
        "status": "https://www.ape-apps.com",
        "statusColor": "#1976D2",
        "tag": "supportforum"
    });

    if(Android.getPlatform() != "2") {
        aboutData.push({
            "title": "Become a Patron",
            "icon": "https://www.apewebapps.com/images/Patreon_Mark_Primary.png",
            "description": "If you like what Ape Apps is doing and would like to see more awesome entertainment like " + Android.getAppName() + ", consider becoming a patron with Patreon!",
            "status": "https://www.patreon.com/apeapps",
            "statusColor": "#F96855",
            "tag": "patreon"
        });
    }

    aboutData.push({
        "title": "Follow Ape Apps",
        "icon": "https://www.apewebapps.com/images/twitter.png",
        "description": "Follow Ape Apps on Twitter.  You know you want to!",
        "status": "@apeapps",
        "statusColor": "#03A9F4",
        "tag": "twitter"
    });

    aboutData.push({
        "title": "Follow the Developer",
        "icon": "https://www.apewebapps.com/images/twitter.png",
        "description": "Why not also follow the developer himself?  All the cool kids have Brandon Stecklein on their twitter.",
        "status": "@bastecklein",
        "statusColor": "#03A9F4",
        "tag": "twitterdev"
    });

    aboutData.push({
        "title": "Watch Ape Apps",
        "icon": "https://www.apewebapps.com/images/youtube.png",
        "description": "Keep up with the best videos on the entire internet by subscribing to the Ape Apps channel on YouTube!",
        "status": "https://www.youtube.com/user/apeapps",
        "statusColor": "#F44336",
        "tag": "youtube"
    });

    aboutData.push({
        "title": "Contact",
        "icon": "https://www.apewebapps.com/images/ind-mail.png",
        "description": "If you want to contact the developer the old fashioned way, you can do that too.  Send your awesome letters to the following address.  If you leave a return address, you will get a reply too!<br /><br /><strong style=\"text-align:center;\">Attn: Brandon Stecklein<br />Ape Apps<br />PO Box 30631<br />Columbia, MO 65205<br />United States of America</strong>",
        "tag": "snailmail"
    });

    if(Android.getPlatform() != "2") {
        aboutData.push({
            "title": "Donation",
            "icon": "https://www.apewebapps.com/images/ind-money.png",
            "description": "If you want to see more glorious low cost entertainment from Ape Apps in the future, consider making a small donation to support future development!",
            "tag": "donation"
        });
    }

    adl.showList({
        title: "About " + Android.getAppName(),
        options: aboutData,
        onSelection: function(tag) {
            if(tag) {
                onAboutItemSelected(tag);
            }
            
        },
        flyout: {
            position: "right"
        }
    });
    
}

function onAboutItemSelected(tag) {
    if(!tag) {
        return;
    }

    if(tag == "metainfo") {
        loadURL(window.shareURL);
    }

    if(tag == "privacy") {
        loadURL("https://apps.ape-apps.com/" + window.appurlid + "/privacy.html");
    }

    if(tag == "patreon") {
        loadURL("https://www.patreon.com/apeapps");
    }

    if(tag == "supportforum") {
        loadURL("https://www.ape-apps.com/viewpage.php?p=4");
    }

    if(tag == "developer") {
        loadURL("https://www.ape-apps.com/profile.php?u=bastecklein");
    }

    if(tag == "twitter") {
        loadURL("https://twitter.com/apeapps");
    }

    if(tag == "twitterdev") {
        loadURL("https://twitter.com/bastecklein");
    }

    if(tag == "youtube") {
        loadURL("https://www.youtube.com/user/apeapps");
    }

    if(tag == "snailmail") {
        loadURL("http://www.mailaletter.com");
    }

    if(tag == "donation") {
        loadURL("https://www.ape-apps.com/donation/");
    }
    

}

function presentFeedbackWindow() {


    inputBox({
        title: "Send Feedback",
        message: "I am always looking for ways to expand and improve " + Android.getAppName() + ".  Updates are made based on user suggestions, so please let me know what updates you want to see!",
        multiline: true,
        password: false,
        placeholder: "Enter Feedback or Suggestions Here!",
        func:  function(text) {
            if(text && text.trim().length > 0) {
                text = text.trim();

                let ape = "";

                if(Android.isApeAppsLoggedIn()) {
                    let apeProfile = getApeAppsProfile();

                    if(apeProfile) {
                        ape = apeProfile.un;
                    }
                }
                

                let platformCode = Android.getPlatform();

                let feedbackData = [
                    { key: "a", value: Android.getApeMarketId() },
                    { key: "p", value: platformCode },
                    { key: "c", value: text },
                    { key: "v", value: Android.getAppVersion() },
                    { key: "d", value: Android.getDeviceName() },
                    { key: "ape", value: ape }
                ];

                dataRequest("https://market.ape-apps.com/app_resources/feedback.php",function(){
                    showToast("Thank you for your feedback!");
                },feedbackData,true);
            }
        }
    });

}

// eslint-disable-next-line no-unused-vars
function getPlatformComplete() {

    let market = "apemarket";

    let platformCode = Android.getPlatform();

    if(platformCode == "2") {
        market = "gplay";
    }

    if(platformCode == "3") {
        market = "amazon";
    }

    if(platformCode == "7") {
        market = "slideme";
    }

    if(platformCode == "8") {
        market = "opera";
    }

    if(platformCode == "9") {
        market = "anzhi";
    }

    if(platformCode == "11") {
        market = "getjar";
    }

    if(platformCode == "12") {
        market = "aptoide";
    }

    return {
        platform: "android",
        market: market,
        os: "android",
        device: Android.getDeviceName()
    };
}

function showAlert(message,title) {
    if(title) {
        adl.showAlertWithTitle(message,title);
    } else {
        adl.showAlert(message);
    }
}

function showProfileOptions() {

    let appName = Android.getAppName();
    
    let profile = getApeAppsProfile();

    let slideoutPosition = "right";

    if(window.innerWidth <= 500) {
        slideoutPosition = "bottom";
    }
    
    let accountOptions = [];

    accountOptions.push({
        title: "Sign Out",
        icon: "https://accounts.ape-apps.com/getavatar.php?u=" + profile.un,
        description: "You are currently signed in to " + appName + " as " + profile.un,
        tag: "signout",
        circleIcon: true
    });

    let premiumStatus = "Not Premium";
    let premiumColor = "#f44336";
    let premiumDesc = "You are using the free ad-support trial of " + appName + ".  Upgrade to the full version to unlock all content, support development, and remove advertising!";

    if(getIsPremium()) {
        premiumStatus = "Premium";
        premiumColor = "#4CAF50";
        premiumDesc = "You are using the premium version of " + appName + "!  Thank you for your support!";
    }

    accountOptions.push({
        title: "Premium Upgrade",
        icon: "cart-outline",
        iconColor: premiumColor,
        description: premiumDesc,
        tag: "premium",
        status: premiumStatus,
        statusColor: premiumColor
    });

    accountOptions.push({
        title: "Manage Account",
        icon: "person-circle-outline",
        iconColor: "#FF9800",
        description: "Manage all of your Ape Apps account settings.  You will be sent to the account management portal.",
        tag: "manage",
        status: "https://accounts.ape-apps.com",
        statusColor: "#1E88E5"
    });

    adl.showList({
        title: profile.un,
        options: accountOptions,
        disableButtons: true,
        onSelection: function(tag) {

            if(tag == "manage") {
                loadURL("https://accounts.ape-apps.com");
            }

            if(tag == "premium") {
                if(!getIsPremium()) {
                    goPremium();
                }
            }

            if(tag == "signout") {
                signOutOfApeApps();
            }
        },
        flyout: {
            position: slideoutPosition
        }
    });
}

function signOutOfApeApps() {
    Android.signOutOfApeApps();
}

// eslint-disable-next-line no-unused-vars
function inputBox(options) {

    if(!options.func) {
        options.func = childWindowObject.webAppCore.inputReturn;
    }

    adl.inputBox(options);


}

// eslint-disable-next-line no-unused-vars
function presentNativeList(title,items,callback,dismissText) {

    let buttons = [];

    if(dismissText) {

        buttons.push({
            text: dismissText,
            func: function(){
                if(callback) {
                    callback(null);
                }
                
            }
        });

    }

    showDialog({
        title: title,
        listItems: items,
        listCallback: function(tag) {
            if(callback) {
                callback(tag);
            }
            
        },
        buttons: buttons
    });

}

function getADL() {
    return adl;
}

function showFriendsList(callback) {

    friendSelectedCallback = callback;

    if(!Android.isApeAppsLoggedIn()) {
        friendSelectedCallback = null;
        return;
    }

    let useForground = "ffffff";

    if(adl.getOverallThemeLight()) {
        useForground = "000000";
    }

    tmpFriendWindow = document.createElement("iframe");
    tmpFriendWindow.seamless = true;
    tmpFriendWindow.className = "sidebarFrame";
    tmpFriendWindow.src = "https://www.apewebapps.com/friends.php?embed=1&fg=" + useForground + "&nm=1";

    console.log("https://www.apewebapps.com/friends.php?embed=1&fg=" + useForground + "&nm=1");
    console.log(tmpFriendWindow);

    let position = "right";

    adl.showDialog({
        customElement: tmpFriendWindow,
        buttons: [],
        flyout: {
            position: position
        }
    });

}

function postToSignalServer(forUser,data) {
    if(!Android.isApeAppsLoggedIn()) {
        console.log("not logged");
        return;
    }

    if(!signalSocket) {
        console.log("no socket");
        return;
    }

    let apeProfile = getApeAppsProfile();

    let signalMessage = {
        "type": "friendsignal",
        "code": "customsignal",
        "for": forUser,
        "from": apeProfile.un,
        "data": data
    };

    let signalPayload = {
        "destination": "awa-friends-signaling-" + apeProfile.un,
        "msg": signalMessage
    };

    signalSocket.emit("gamemessage",signalPayload);
}

function setFriendsStatus(statusObj) {
    lastFriendsStatus = statusObj;
    updateFriendsNetworkStatus(statusObj);
}

function injectStylesheet(sheet) {
    let fullURL = "app/" + sheet;

    let theTag = document.getElementById("cust-sheet-" + sheet);

    if(!theTag) {
        theTag = document.createElement("link");
        theTag.rel = "stylesheet";
        theTag.type = "text/css";
        theTag.id = "cust-sheet-" + sheet;
        document.head.appendChild(theTag);
    }

    theTag.href = fullURL;
}

function removeStylesheet(sheet) {
    let theTag = document.getElementById("cust-sheet-" + sheet);

    if(theTag) {
        document.head.removeChild(theTag);
    }
}

function injectCustomCSS(tag,rawCSS) {
    let theTag = document.getElementById("cust-rawcss-" + tag);

    if(!theTag) {
        theTag = document.createElement("style");
        theTag.id = "cust-rawcss-" + tag;
        document.head.appendChild(theTag);
    }

    theTag.innerHTML = rawCSS;
}

function removeCustomCSS(tag) {
    let theTag = document.getElementById("cust-rawcss-" + tag);

    if(theTag) {
        document.head.removeChild(theTag);
    }
}

function injectFontFace(family,url,display,weight,style) {
    let tag = "cust-fontface-" + family;
    let fullURL = "app/" + url;
    let fontContent = "@font-face { font-family: '" + family + "'; src: url('" + fullURL + "'); ";

    if(display) {
        tag += "-disp" + display;
        fontContent += "font-display: " + display + "; ";
    }

    if(weight) {
        tag += "-weight" + weight;
        fontContent += "font-weight: " + weight + "; ";
    }

    if(style) {
        tag += "-style" + style;
        fontContent += "font-style: " + style + "; ";
    }

    fontContent += "}";

    let theTag = document.getElementById(tag);

    console.log(tag);
    console.log(fontContent);

    if(!theTag) {
        theTag = document.createElement("style");
        theTag.id = tag;
        document.head.appendChild(theTag);
    }

    theTag.innerHTML = fontContent;
}

function removeFontFace(family,display,weight,style) {
    let tag = "cust-fontface-" + family;

    if(display) {
        tag += "-disp" + display;
    }

    if(weight) {
        tag += "-weight" + weight;
    }

    if(style) {
        tag += "-style" + style;
    }

    let theTag = document.getElementById("cust-rawcss-" + tag);

    if(theTag) {
        document.head.removeChild(theTag);
    }
}